<?php

namespace App\Policies;

use App\Models\CourseSchedule;
use App\Models\User;

class CourseSchedulePolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->hasPermissionTo('view-schedule');
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, CourseSchedule $courseSchedule): bool
    {
        return $user->hasPermissionTo('view-schedule');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->hasPermissionTo('create-schedule');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, CourseSchedule $courseSchedule): bool
    {
        return $user->hasPermissionTo('update-schedule');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, CourseSchedule $courseSchedule): bool
    {
        return $user->hasPermissionTo('delete-schedule');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, CourseSchedule $courseSchedule): bool
    {
        return $user->hasPermissionTo('delete-schedule');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, CourseSchedule $courseSchedule): bool
    {
        return $user->hasPermissionTo('delete-schedule');
    }
}
